#include <stdio.h>
#include "type_system.h"

int main(int argc, char **argv)
{
  struct Option *opt1 = T_define_option();
  opt1->key = T_string("num");
  opt1->type = T_integer(100000);
  opt1->description = T_string("Number of potential types");
  opt1->key->print(opt1->key);
  opt1->description->print(opt1->description);
  opt1->type->print(opt1->type);

  struct Option *opt2 = T_define_option();
  opt2->key = T_string("dists");
  opt2->type = T_integer_subrange(1, 10, 2);
  opt2->description = T_string("Distance in [m]");
  opt2->key->print(opt2->key);
  opt2->description->print(opt2->description);
  opt2->type->print(opt2->type);

  size_t *array;
  array = (size_t*)calloc(5, sizeof(size_t));
  array[0] = 3;
  array[1] = 5;
  array[2] = 7;
  array[3] = 9;
  array[4] =11;

  struct Option *opt3 = T_define_option();
  opt3->key = T_string("win");
  opt3->type = T_integer_enumeration(5, array);
  opt3->description = T_string("Available window sizes");
  opt3->key->print(opt3->key);
  opt3->description->print(opt3->description);
  opt3->type->print(opt3->type);

  struct Option *opt4 = T_define_option();
  opt4->key = T_string("dist");
  opt4->type = T_real(200.0);
  opt4->description = T_string("Distance in [m]");
  opt4->key->print(opt4->key);
  opt4->description->print(opt4->description);
  opt4->type->print(opt4->type);

  struct Option *opt5 = T_define_option();
  opt5->key = T_string("val");
  opt5->type = T_real_subrange(100.0, True, 200.0, True);
  opt5->description = T_string("Values in between");
  opt5->key->print(opt5->key);
  opt5->description->print(opt5->description);
  opt5->type->print(opt5->type);



  return 1;
}
